--Settings:
--------------------------------------------------------------------------------------------------------------------
-- Bar width, Bar height, Fontsize and Transparency can be set ingame (Esc -> Interface -> AddOns -> PowertTrackerBar)
--------------------------------------------------------------------------------------------------------------------
PTBarSettings = {
	StatusTex = [[Interface\AddOns\PowerTrackerBar\Media\Bubble.tga]],
	PanelTex = [[Interface\AddOns\PowerTrackerBar\Media\Flat.tga]],
	font = [[Interface\AddOns\PowerTrackerBar\Media\font.ttf]],
}

local Focus_prediction = 1	-- use Focus prediction for Hunter (Cobra, Steady, Focusing Shot) (1 = yes; 0 = no)

--Coloring Settings:
local bar_classcolor = 1 	-- use class color? (1 = yes; 0 = no)

local bar_color_red = 1 	-- Color of powerbar 0 to 1, e.g.: .7 (bar_classcolor must be set to 0)
local bar_color_green = 1	-- Color of powerbar 0 to 1, e.g.: .7 (bar_classcolor must be set to 0)
local bar_color_blue = 0	-- Color of powerbar 0 to 1, e.g.: .7 (bar_classcolor must be set to 0)
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------

local _, class = UnitClass("player")
local r,g,b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b

--Background:
local PTBarBG = CreateFrame("Frame", "PTBarBG", UIParent)
PTBarBG:SetPoint("BOTTOMLEFT", UIParent, "CENTER", -200, -50)
PTBarBG:SetBackdrop({
	bgFile = PTBarSettings.PanelTex, 
	edgeFile = PTBarSettings.PanelTex, 
	tile = false, tileSize = 0, edgeSize = 1, 
	insets = { left = -1, right = -1, top = -1, bottom = -1}
})
PTBarBG:SetMovable(true)
PTBarBG:SetResizable(true)
PTBarBG:SetClampedToScreen(true)
PTBarBG:SetUserPlaced(true)
--Hide in PetBattle
PetBattleFrame:HookScript("OnShow",function()
	PTBarBG:Hide()
end)
PetBattleFrame:HookScript("OnHide",function()
	PTBarBG:Show()
end)

--Bar:
local TimeSinceLastUpdate = 1
local PTBar = CreateFrame("StatusBar", "PTBar", PTBarBG)
PTBar:SetStatusBarTexture(PTBarSettings.StatusTex)
PTBar:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)
PTBar:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)

PTBar:SetScript("OnUpdate", function(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	if (TimeSinceLastUpdate >= 1) then
		self:SetMinMaxValues(0, UnitPowerMax("player"))
		self:SetValue(UnitPower("player"))
	end
end)

--Text:
local text = PTBar:CreateFontString(nil, "OVERLAY")
text:SetPoint("CENTER", PTBarBG, "CENTER")

if class == "MONK" then
	local function MONK_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 12)
		text:SetText(Power .. ' - ' .. altpower)
	end
	PTBar:SetScript("OnEvent", MONK_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "ROGUE" then
	local function ROGUE_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local anticipation_selected = select(4, GetTalentInfoByID(19250, GetActiveSpecGroup()))
		local anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
		
		if class == "ROGUE" then anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
			if not anticipation_stacks then anticipation_stacks = 0 end
		end		
		if anticipation_selected == true then
			if PowerTrackerBarMergeCP:GetChecked() == true then
				text:SetText(Power .. ' - ' .. altpower+anticipation_stacks)
			elseif PowerTrackerBarMergeCP:GetChecked() == false then
				text:SetText(Power .. ' - ' .. altpower .. ' - ' .. anticipation_stacks)
			end
		else
			text:SetText(Power .. ' - ' .. altpower)
		end
	end
	PTBar:SetScript("OnEvent", ROGUE_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
	PTBar:RegisterEvent("UNIT_AURA")
	PTBar:RegisterEvent("PLAYER_STARTED_MOVING")
	
elseif class == "DRUID" then
	local function DRUID_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local ShapeshiftForm = GetShapeshiftForm()
		
		if ShapeshiftForm == 2 or altpower >= 1 then
			text:SetText(Power .. ' - ' .. altpower)
		else
			text:SetText(Power)
		end			
	end
	PTBar:SetScript("OnEvent", DRUID_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")	
	
elseif class == "PALADIN" then
	local function PALADIN_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 9)
		text:SetText(Power .. ' - ' .. altpower)
	end
	PTBar:SetScript("OnEvent", PALADIN_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "HUNTER" then
	local function HUNTER_TEXT()
		local Power = (UnitPower("player"))
		local PlayerCast, _, _, _, _, endTime = UnitCastingInfo("player")
		
		if (PlayerCast == "Cobra Shot" or PlayerCast == "Steady Shot" or PlayerCast == "Focusing Shot") and Focus_prediction == 1 then --Focus prediction for hunters (text)
			local regen = GetPowerRegen()
			local timeLeft = endTime/1000 - GetTime()
			local cast_regen = (regen * timeLeft)
			if PlayerCast == "Cobra Shot" or PlayerCast == "Steady Shot" then
				text:SetText(Power.. '(' .. (Power+ceil(cast_regen+14)) .. ')')
			elseif PlayerCast == "Focusing Shot" then
				text:SetText(Power.. '(' .. (Power+ceil(cast_regen+50)) .. ')')
			end
		else text:SetText(Power)
		end		
	end
	PTBar:SetScript("OnEvent", HUNTER_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
	
else
	local function else_TEXT()
		local Power = (UnitPower("player"))
		text:SetText(Power)
	end
	PTBar:SetScript("OnEvent", else_TEXT)
	PTBar:RegisterEvent("UNIT_POWER")
	PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
end

--Focus prediction for hunters (bar):
if class == "HUNTER" and Focus_prediction == 1 then
	local PTBar_prediction = CreateFrame("StatusBar", "PTBar_prediction", PTBarBG)
	PTBar_prediction:SetStatusBarTexture(PTBarSettings.StatusTex)
	PTBar_prediction:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)
	PTBar_prediction:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)
	
	PTBar_prediction:SetScript("OnUpdate", function(self, elapsed)
		
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if (TimeSinceLastUpdate >= 1) then
			self:SetMinMaxValues(0, UnitPowerMax("player"))	
			if UnitCastingInfo("player") == "Cobra Shot" or UnitCastingInfo("player") == "Steady Shot" or UnitCastingInfo("player") == "Focusing Shot" then
				if UnitCastingInfo("player") == "Cobra Shot" or UnitCastingInfo("player") == "Steady Shot" then	
					self:SetValue((UnitPower("player")+14))
				elseif UnitCastingInfo("player") == "Focusing Shot" then
					self:SetValue(UnitPower("player")+50)
				end
			else self:SetValue(0)
			end
		end
	end)
end


-- Everything below this line is for ingame Options (Option panel and slash command):
--------------------------------------------------------------------------------------------------------------------
-- Create an entry for Interface -> AddOns
PowerTrackerBar = {};
PowerTrackerBar.panel = CreateFrame( "Frame", "PowerTrackerBarPanel", UIParent );
PowerTrackerBar.panel.name = "PowerTrackerBar";
InterfaceOptions_AddCategory(PowerTrackerBar.panel);

-- Text Settings Headline (PowerTrackerBar Settings:)
local Settingstext = PowerTrackerBar.panel:CreateFontString("Settingstext")
Settingstext:SetFontObject('GameFontNormalLarge')
Settingstext:SetPoint("TOPLEFT", 5,-5)
Settingstext:SetText('PowerTrackerBar Settings:')

-- Text Settings Small (Type /ptb to unlock)
local Settingstext2 = PowerTrackerBar.panel:CreateFontString("Settingstext2")
Settingstext2:SetFontObject('GameFontNormalSmall')
Settingstext2:SetPoint("TOPLEFT", 5,-30)
Settingstext2:SetText('Type /ptb to unlock')

-- Slider for Width
local SliderWidth = CreateFrame("Slider","PowerTrackerBarSliderWidth",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderWidth:SetPoint("TOPLEFT",40,-70)
_G[SliderWidth:GetName() .. 'Low']:SetText('40');
_G[SliderWidth:GetName() .. 'High']:SetText('300');
SliderWidth:SetMinMaxValues(40, 300)
SliderWidth:SetValueStep(1)

-- Save the Width in the SavedVariables and set the Width ingame
SliderWidth:SetScript("OnValueChanged", function(self)
	local value = self:GetValue()
	
	PowerTrackerBarSettings.SliderWidthvalue = value
	
	PTBarBG:SetWidth(value)
	_G[SliderWidth:GetName() .. 'Text']:SetText('Bar Width: '.. ceil(SliderWidth:GetValue()));
end)

--Slider for Height
local SliderHeight = CreateFrame("Slider","PowerTrackerBarSliderHeight",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderHeight:SetPoint("TOPLEFT",40,-125)
_G[SliderHeight:GetName() .. 'Low']:SetText('20');
_G[SliderHeight:GetName() .. 'High']:SetText('100');
SliderHeight:SetMinMaxValues(20, 100)
SliderHeight:SetValueStep(1)

-- Save the Height in the SavedVariables and set the Height ingame
SliderHeight:SetScript("OnValueChanged", function(self)
	local value = self:GetValue()
	
	PowerTrackerBarSettings.SliderHeightvalue = value
	
	PTBarBG:SetHeight(value)
	_G[SliderHeight:GetName() .. 'Text']:SetText('Bar Height: '.. ceil(SliderHeight:GetValue()));
end)

-- Slider for Transparency (opacity)
local SliderTransparency = CreateFrame("Slider","PowerTrackerBarSliderTransparency",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderTransparency:SetPoint("TOPLEFT",40,-180)
_G[SliderTransparency:GetName() .. 'Low']:SetText('0%');
_G[SliderTransparency:GetName() .. 'High']:SetText('100%');
SliderTransparency:SetMinMaxValues(0, 1)
SliderTransparency:SetValueStep(.05)

-- Save the Transparency in the SavedVariables and set the Transparency ingame (ingame Silder name: Opacity)
SliderTransparency:SetScript("OnValueChanged", function(self)
	local value = self:GetValue()
	
	PowerTrackerBarSettings.SliderTransparencyvalue = value
	
	PTBarBG:SetBackdropColor(0,0,0,value)
	PTBarBG:SetBackdropBorderColor(.2,.2,.2,value)
	if bar_classcolor == 1 then
		PTBar:SetStatusBarColor(r,g,b,value)
	end
	if bar_classcolor == 0 then
		PTBar:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,value)
	end
	
	if class == "HUNTER" then
		local predictiontransparency = value / 1.5
		if bar_classcolor == 1 then
			PTBar_prediction:SetStatusBarColor(r,g,b,predictiontransparency)
		end
		if bar_classcolor == 0 then
			PTBar_prediction:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,predictiontransparency)
		end
	end
	_G[SliderTransparency:GetName() .. 'Text']:SetText('Opacity: '.. ceil(SliderTransparency:GetValue()*100)..'%');
end)

-- Slider for Fontsize
local SliderFontsize = CreateFrame("Slider","PowerTrackerBarSliderFontsize",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderFontsize:SetPoint("TOPLEFT",40,-235)
_G[SliderFontsize:GetName() .. 'Low']:SetText('10');
_G[SliderFontsize:GetName() .. 'High']:SetText('35');
SliderFontsize:SetMinMaxValues(10, 35)
SliderFontsize:SetValueStep(1)

-- Save the Fontsize in the SavedVariables and set the Fontsize ingame
SliderFontsize:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderFontsizevalue = value
	
	text:SetFont(PTBarSettings.font, value, "THINOUTLINE")
	_G[SliderFontsize:GetName() .. 'Text']:SetText('Fontsize: '.. ceil(SliderFontsize:GetValue()));
end)

-- Option to hide the Bar out of combat
local HideOOCtext = PowerTrackerBar.panel:CreateFontString("SettingstextRogue")
HideOOCtext:SetFontObject('GameFontNormalSmall')
HideOOCtext:SetPoint("TOPLEFT", 70,-305, "CENTER")
HideOOCtext:SetText('Only show in combat')

local HideOOC = CreateFrame("CheckButton", "PowerTrackerBarHideOOC", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
HideOOC:SetPoint("TOPLEFT", 40, -300, "CENTER");
HideOOC.tooltip = "Show the PowerTrackerBar only in combat";

HideOOC:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	
	PowerTrackerBarSettings.HideOOCvalue = state
	
	if self:GetChecked() == true then
		PTBarBG:Hide()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Hide()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	elseif self:GetChecked() == false then
		PTBarBG:Show()
	end
end
);
HideOOC:RegisterEvent("ADDON_LOADED")
HideOOC:SetScript("OnEvent", function(self)
	
	if PowerTrackerBarSettings.HideOOCvalue == nil then
		HideOOC:SetChecked(false)
	elseif PowerTrackerBarSettings.HideOOCvalue == true then
	HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)
	PTBarBG:Hide()
	local PTBar_hide = CreateFrame("Frame")
	local function HideOrShow(self, event, ...)
		if event == "PLAYER_REGEN_DISABLED" then
			PTBarBG:Show()
			
		elseif event == "PLAYER_REGEN_ENABLED" then
			PTBarBG:Hide()
		end
	end
	PTBar_hide:SetScript("OnEvent",HideOrShow)
	PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
	PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	
	else HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)		
	end
end)


-- Load the values from the SavedVariables, if SavedVariables == nil load default
PowerTrackerBar.panel:RegisterEvent("ADDON_LOADED")
PowerTrackerBar.panel:SetScript("OnEvent", function(self)
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		PTBarBG:SetWidth(181)
	else
		PTBarBG:SetWidth(PowerTrackerBarSettings.SliderWidthvalue)
	end
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		PTBarBG:SetHeight(26)
	else
		PTBarBG:SetHeight(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		text:SetFont(PTBarSettings.font, 16, "THINOUTLINE")
	else
		text:SetFont(PTBarSettings.font, PowerTrackerBarSettings.SliderFontsizevalue, "THINOUTLINE")
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then	
		PTBarBG:SetBackdropColor(0,0,0,.7)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,.7)
		
		if bar_classcolor == 1 then
			PTBar:SetStatusBarColor(r,g,b,.7)
		end
		if bar_classcolor == 0 then
			PTBar:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,.7)
		end
		
		if class == "HUNTER" then
			local predictiontransparency = .7 / 1.5
			if bar_classcolor == 1 then
				PTBar_prediction:SetStatusBarColor(r,g,b,predictiontransparency)
			end
			if bar_classcolor == 0 then
				PTBar_prediction:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,predictiontransparency)
			end
		end
	else
		PTBarBG:SetBackdropColor(0,0,0,PowerTrackerBarSettings.SliderTransparencyvalue)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,PowerTrackerBarSettings.SliderTransparencyvalue)
		
		if bar_classcolor == 1 then
			PTBar:SetStatusBarColor(r,g,b,PowerTrackerBarSettings.SliderTransparencyvalue)
		end
		if bar_classcolor == 0 then
			PTBar:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,PowerTrackerBarSettings.SliderTransparencyvalue)
		end
		
		if class == "HUNTER" then
			local predictiontransparency = PowerTrackerBarSettings.SliderTransparencyvalue / 1.5
			if bar_classcolor == 1 then
				PTBar_prediction:SetStatusBarColor(r,g,b,predictiontransparency)
			end
			if bar_classcolor == 0 then
				PTBar_prediction:SetStatusBarColor(bar_color_red,bar_color_green,bar_color_blue,predictiontransparency)
			end
		end
	end
end)

-- Set the Silder to the SavedVariables values, if SavedVariables == nil set to default
PowerTrackerBar.panel.refresh = function()
	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		SliderWidth:SetValue(181)
	else
		SliderWidth:SetValue(PowerTrackerBarSettings.SliderWidthvalue)
	end
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		SliderHeight:SetValue(16)
	else
		SliderHeight:SetValue(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		SliderTransparency:SetValue(.7)
	else
		SliderTransparency:SetValue(PowerTrackerBarSettings.SliderTransparencyvalue)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		SliderFontsize:SetValue(16)
	else
		SliderFontsize:SetValue(PowerTrackerBarSettings.SliderFontsizevalue)
	end
end

-- Option to merge Combopoints with Anticipation stacks. E.g. 5cp + 2 Anticipation gets displayed as 7
if class == "ROGUE" then
	local SettingstextRogue = PowerTrackerBar.panel:CreateFontString("SettingstextRogue")
	SettingstextRogue:SetFontObject('GameFontNormalSmall')
	SettingstextRogue:SetPoint("TOPLEFT", 70,-325, "CENTER")
	SettingstextRogue:SetText('Merge Combopoints with Anticipation')

	local MergeCP = CreateFrame("CheckButton", "PowerTrackerBarMergeCP", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
	MergeCP:SetPoint("TOPLEFT", 40, -320, "CENTER");
	MergeCP.tooltip = "Merge Combopoints with Anticipation stacks. E.g. 5cp + 2 Anticipation gets displayed as 7.";
	
	MergeCP:SetScript("OnClick", function(self)
		local state = self:GetChecked()
		
		PowerTrackerBarSettings.MergeCPvalue = state
		
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local anticipation_selected = select(4, GetTalentInfoByID(19250, GetActiveSpecGroup()))
		local anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
		
		if class == "ROGUE" then anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
			if not anticipation_stacks then anticipation_stacks = 0 end
		end		
		if anticipation_selected == true then
			if self:GetChecked() == true then
				text:SetText(Power .. ' - ' .. altpower+anticipation_stacks)
			elseif self:GetChecked() == false then
				text:SetText(Power .. ' - ' .. altpower .. ' - ' .. anticipation_stacks)
			end
		else
			text:SetText(Power .. ' - ' .. altpower)
		end
	end
	);
	MergeCP:RegisterEvent("ADDON_LOADED")
	MergeCP:SetScript("OnEvent", function(self)
		
		if PowerTrackerBarSettings.MergeCPvalue == nil then
			MergeCP:SetChecked(false)
		else
			MergeCP:SetChecked(PowerTrackerBarSettings.MergeCPvalue)
		end
	end)
end


-- Create Resize frame in the bottom right corner
local resizeButton = CreateFrame("Button", nil, PTBarBG)
resizeButton:SetSize(16, 16)
resizeButton:SetPoint("CENTER", PTBar, "BOTTOMRIGHT")
resizeButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
resizeButton:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
resizeButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
--hide it in default state
resizeButton:RegisterEvent("PLAYER_ENTERING_WORLD")
resizeButton:SetScript("OnEvent", function(self)
	self:Hide()
end)

--slash command (drag to move or hold lower right corner to resize)
local PTBmove = false 
local function POWER()
	if not PTBmove then
		-- Resize:
		resizeButton:Show()
		resizeButton:SetScript("OnMouseDown", function(self, button) 	-- allows resizing of the frame while clicking on the Resize frame
			PTBarBG:StartSizing("BOTTOMRIGHT")
			PTBarBG:SetUserPlaced(true)
		end)
		resizeButton:SetScript("OnMouseUp", function(self, button)
			PTBarBG:StopMovingOrSizing()
		end)
		-- Drag:
		PTBarBG:RegisterForDrag("LeftButton")
		PTBarBG:SetScript("OnDragStart", PTBarBG.StartMoving)
		PTBarBG:SetScript("OnDragStop", PTBarBG.StopMovingOrSizing)
		
		print("Power Tracker Bar unlocked, type /ptb to save. Bar width, Bar height, Fontsize and Opacity can be set in the option menue (Esc -> Interface -> AddOns -> PowertTrackerBar)")
		PTBmove = true
		PTBarBG:EnableMouse(true)
	elseif PTBmove == true then
		resizeButton:Hide()
		if PTBarBG:GetWidth() <= 40 then PTBarBG:SetWidth(40) end
		if PTBarBG:GetHeight() <= 20 then PTBarBG:SetHeight(20) end
		PowerTrackerBarSettings.SliderWidthvalue = PTBarBG:GetWidth() -- save new width/height in SavedVariables
		PowerTrackerBarSettings.SliderHeightvalue = PTBarBG:GetHeight() -- save new width/height in SavedVariables
		PTBarBG:EnableMouse(false)
		PTBmove = false
		print("Power Tracker Bar locked")
	end
end
SLASH_POWER1 = "/PTB"
SlashCmdList["POWER"] = POWER